
struc	TCHAR text&
{   . db text
    label .SizeOf at 1
    label .Length at $ - .
      db 0
    label .Bytes at $ - .
}

struc	assume	base*, type&
{   if ~type eq
      virtual at base
	. type
	if ~ definite .Length
	  label .Length at $ - $$
	end if
      end virtual
    else
      label . at base
      label .Length at 0
    end if
}

define proc_flag.all	0x1FFFF
define proc_flag.arg	0x20000
define proc_flag.fix	0x40020
define proc_flag.r10	0x00400
define proc_flag.r11	0x00800
define proc_flag.r12	0x01000
define proc_flag.r13	0x02000
define proc_flag.r14	0x04000
define proc_flag.r15	0x08000
define proc_flag.r8	0x00100
define proc_flag.r9	0x00200
define proc_flag.rax	0x00001
define proc_flag.rbp	0x00020
define proc_flag.rbx	0x00008
define proc_flag.rcx	0x00002
define proc_flag.rdi	0x00080
define proc_flag.rdx	0x00004
define proc_flag.rfl	0x00010
define proc_flag.rip	0x10000
define proc_flag.rsi	0x00040
define proc_flag.rsp	0x00000

macro	proc  name, spec&
{   @@:
    name:
    postpone \{ if defined name#.currentStack
        name#.currentFrame = name#.currentStack
      end if
    \}
    .currentStack = 0
    local .flag, .size
    .flag = 0
    if ~ spec eq
      irp val, spec
      \{ if val in <register, fastcall, cdecl, stdcall>
	  if .flag and proc_flag.rip = 0
	    .flag = .flag or proc_flag.rip
	  else
	    err
	  end if
	  if val in <fastcall, stdcall>
	    .flag = .flag or proc_flag.arg
	  end if
	  if val in <cdecl, stdcall>
	    .flag = .flag or proc_flag.fix
	  end if
	else if val in <rax, rbx, rcx, rdx, rbp, rsi, rdi, r8, r9,\
			r10, r11, r12, r13, r14, r15, rfl, all>
	  .flag = .flag or proc_flag.\#val
	else
	  err
	end if
      \}
    end if
    if .flag and proc_flag.rip = 0
      .flag = .flag or proc_flag.rip or proc_flag.fix or proc_flag.arg
    end if
    if .flag and proc_flag.fix = 0
      label .locals at rsp
    else
      label .locals at rbp - .loclen
    end if
    virtual at .locals + .loclen
      @@:irps reg, rip rfl rax rcx rdx rbx rsp rbp rsi rdi r8 r9 r10 r11 r12 r13 r14 r15
      \{ reverse if .flag and proc_flag.\#reg <> 0
	  .pushed_\#reg dq ?
	end if
      \}
      label .alignStack at ($ - @b ) and 15
      if .flag and proc_flag.arg <> 0
        label .argbeg
      end if
}

macro	var
{     if ~ definite .locals
        err
      end if
      if definite .argbeg
	label .arglen at ( 0 - 16 ) and ( $ - .argbeg + 15 )
      else
        label .arglen at 0
      end if
    end virtual
    virtual at .locals
      rb .currentFrame
}

macro	begin	this&
{     if ~ definite .arglen | defined @f
	@@: var
      end if
      label .loclen at ( 0 - 16 ) and ( $ - .locals + 15 ) + .alignStack
    end virtual
    label .begin
    if definite .pushed_rfl
	pushfq
    end if
    irps reg, rax rcx rdx rbx rsp rbp rsi rdi r8 r9 r10 r11 r12 r13 r14 r15
    \{ forward if definite .pushed_\#reg
	push	reg
      end if
    \}
    if .locals relativeto rbp
	mov	rbp, rsp
      if .loclen <> 0
	lea	rsp, [.locals]
      end if
    else if .loclen <> 0
	lea	rsp, [rsp - .loclen]
    end if
    if ~ this eq
      virtual at rcx
	.this this
	if ~definite .Length
	  label .Length at $ - $$
	end if
      end virtual
    end if
    @@:
}

macro	return	status=nop, value=rax
{   if ~ definite .begin
      err
    end if
    if ~ value eq rax
      local .chk, .val
      label .chk
      match =addr val, value \{ lea	rax, val \}
      match =double val, value \{ mov	rax, val \}
      match =float val, value \{ mov	eax, val \}
      match =qword val, value \{ mov	rax, val \}
      match =dword val, value \{ mov	eax, val \}
      match =word val, value \{ mov	ax, val \}
      match =byte val, value \{ mov	al, val \}
      if $ = .chk
        if value in <al, ah, ax, bl, bh, bx, cl, ch, cx, dl, dh, dx,\
			spb, spl, sp, bpb, bpl, bp, sib, sil, si, dib, dil, di,\
			r8b, r8l, r8w, r9b, r9l, r9w, r10b, r10l, r10w,\
			r11b, r11l, r11w, r12b, r12l, r12w, r13b, r13l, r13w,\
			r14b, r14l, r14w, r15b, r15l, r15w>
	  movsx	rax, value
	else if value in <ebx, ecx, edx, esp, ebp, esi, edi, r8d, r9d,\
			r10d, r11d, r12d, r13d, r14d, r15d>
	  mov	eax, value
	end if
      end if
      if $ = .chk
        virtual at 0
	  mov	rax, value
		dq 0
	  load .val qword from 3
        end virtual
;        if .val = 0
;	  xor	eax, eax
;        else if .val = -1
;          or	eax, -1
;	else
	  mov	rax, value
;        end if
      end if
      if definite .pushed_rax
	mov	[.pushed_rax], rax
      end if
    end if
    if .locals relativeto rbp
	mov	rsp, rbp
    else if .loclen <> 0
	lea	rsp, [rsp + .loclen]
    end if
    irps reg, rax rcx rdx rbx rsp rbp rsi rdi r8 r9 r10 r11 r12 r13 r14 r15
    \{ reverse if definite .pushed_\#reg
	pop	reg
      end if
    \}
    if definite .pushed_rfl
	popfq
    end if
    if status in <OK, clc, Done>
	clc
    else if status in <ER, stc, Fail>
	stc
    else if ~ status in <DC, nop, Back>
      err
    end if
    if .arglen <> 0
	retn	.arglen
    else
	retn
    end if
}

macro	invadd	data, type
{   local .string
    match value, data \{ macro	arglist
    \\{	arglist
	.string	TCHAR value
    \\} \}
    define data [.string]
    define type const
}

macro	invreg	data, type, size, [xmm, reg, red, rew, reb, val]
{   reverse
      size = 0
      define type integer
      define data val
      match =double value, data
      \{ define data value
	 define type float
	 size = 8
      \}
      match =float value, data
      \{ define data value
	 define type float
	 size = 4
      \}
      match =addr value, data
      \{ define data value
	 define type addr
      \}
      match any=,any, data \{ invadd data, type \}
      match any, data \{ match \`any, any \\{ invadd data, type \\} \}
      match arg, data
      \{ local opcode
	 if arg eqtype 0 | arg eqtype 0f | type eq addr | type eq const
	   if size = 0
	     size = 8
	   end if
	 else if arg eqtype byte 0 | arg eqtype byte 0f
	   match prefix value, data
	   \\{   if prefix eq qword
	      size = 8
	    else if prefix eq dword
	      size = 4
	    else if prefix eq word
	      size = 2
	    else if prefix eq byte
	      size = 1
	    end if
	   \\}
	 else if ~ arg in <xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6, xmm7,\
		xmm8, xmm9, xmm10, xmm11, xmm12, xmm13, xmm14, xmm15>
	   virtual at 0
	     inc arg
	     db 0
	     load opcode word from 0
	   end virtual
	   if opcode and 0xFF = 0x67 | opcode and 0xFF = 0x41
	     opcode = opcode shr 8
	   end if
	   if opcode and 0xF8 = 0x48
	     size = 8
	   else if opcode and 0xFF = 0x66
	     size = 4
	   else if opcode and 0xFF = 0xFF
	     size = 2
	   else
	     size = 1
	   end if
	 end if
	if size = 8
	  if type eq float
	    if ~xmm eq arg
	      if arg eqtype 0 | arg eqtype 0f
		mov	reg, arg
		if xmm in <xmm0, xmm1, xmm2, xmm3>
		  movq	xmm, reg
		else
		  mov	xmm, reg
		end if
	      else
		movq	xmm, arg
	      end if
	    end if
	  else if type eq addr | type eq const
	    if ~ arg eq reg
	      lea reg, arg
	    end if
	  else if ~ arg eq reg
	    mov	reg, arg
	  end if
	else if size = 4
	  if type eq float
	    if ~ xmm eq arg
	      if arg eqtype 0 | arg eqtype 0f
		mov	red, arg
		if xmm in <xmm0, xmm1, xmm2, xmm3>
		  movd	xmm, red
		else
		  mov	xmm, red
		end if
	      else
		movd	xmm, arg
	      end if
	    end if
	  else if ~ arg eq red
	    mov	red, arg
	  end if
	else if size = 2
	  if ~ arg eq rew
	    mov	rew, arg
	  end if
	else if size = 1
	  if ~ arg eq reb
	    mov	reb, arg
	  end if
	end if
      \}
}

macro	invarg	count, vcx=rcx, vdx=rdx, v08=r8, v09=r9, [args]
{   common local .count, .data, .jump, .size, .skip, .type
      macro arglist \{ \}
      .count = 4
      if count <> 0
	lea	rsp, [rsp - count]
      end if
      define .list
      if ~args eq
    forward invreg .data, .type, .size,\
		   [rsp + .count * 8], rcx, ecx, cx, cl, args
	if ~ .type eq float
	  mov	[rsp + .count * 8], rcx
	end if
	.count = .count + 1
    common end if
      .count = ( 8 * .count + 15 ) and -16
      if definite .currentStack
	if .currentStack < .count
	  .currentStack = .count
	end if
	.count = 0
      end if
      count = .count
      invreg	.data, .type, .size,\
		xmm0, rcx, ecx,  cx,  cl, vcx, xmm1, rdx, edx,  dx,  dl, vdx,\
		xmm2, r8,  r8d, r8w, r8l, v08, xmm3, r9,  r9d, r9w, r9l, v09
      if .jump <> .skip
	jmp	.skip
      end if
      .jump: arglist
      .skip: irpv arglist, val \{ \purge val \}
      irpv .data, val \{ \restore val \}
      irpv .type, val \{ \restore val \}
}

macro	invoke	proc*, args&
{   local .alen, .count, .proc
    if ~ args eq
	invarg	.count, args
    else
      .count = 0
    end if
	call	 proc
    .alen = 0
    define .proc proc
    match =[name=], .proc
    \{ if defined name\#.arglen
         .alen = name\#.arglen
       end if
       define .proc
    \}
    match name, .proc
    \{ if defined name\#.arglen
         .alen = name\#.arglen
       end if
    \}
    if .count > .alen
      if definite .locals
	if ~ .locals relativeto rsp
	    lea	rsp, [.locals]
	else
	  lea	rsp, [rsp + .count - .alen]
	end if
      else
	lea	rsp, [rsp + .count - .alen]
      end if
    end if
    irpv .proc, val \{ \restore val \}
}