
struc   KEY_EVENT_RECORD
{   label .
    .bKeyDown			db ?	;  BOOL  bKeyDown;
    .wRepeatCount		dw ?	;  WORD  wRepeatCount;
    .wVirtualKeyCode		dw ?	;  WORD  wVirtualKeyCode;
    .wVirtualScanCode		dw ?	;  WORD  wVirtualScanCode;
    label .AsciiChar byte
    .UnicodeChar		du ?	;  union {
					;    WCHAR UnicodeChar;
					;    CHAR  AsciiChar;
					;  } uChar;
    .dwControlKeyState		dd ?	;  DWORD dwControlKeyState;
    label .Length at $ - .
}

struc   MOUSE_EVENT_RECORD
{   label .
    .dwMousePosition		_COORD	;  COORD dwMousePosition;
    .dwButtonState		dd ?	;  DWORD dwButtonState;
    .dwControlKeyState		dd ?	;  DWORD dwControlKeyState;
    .dwEventFlags		dd ?	;  DWORD dwEventFlags;
    label .Length at $ - .
}

struc   WINDOW_BUFFER_SIZE_RECORD
{   label .
    .dwSize			_COORD	;  COORD dwSize;
    label .Length at $ - .
}

struc   MENU_EVENT_RECORD
{   label .
    .dwCommandId		dd ?	;  UINT dwCommandId;
    label .Length at $ - .
}

struc   FOCUS_EVENT_RECORD
{   label .
    .bSetFocus			db ?    ;  BOOL bSetFocus;
    label .Length at $ - .
}

struc   _INPUT_RECORD
{   label .
    .EventType			dw ?    ;  WORD  EventType;
    virtual
    .KeyEvent			KEY_EVENT_RECORD
    end virtual
    virtual
    .MouseEvent			MOUSE_EVENT_RECORD
    end virtual
    virtual
    .WindowBufferSizeEvent	WINDOW_BUFFER_SIZE_RECORD
    end virtual
    virtual
    .MenuEvent			MENU_EVENT_RECORD
    end virtual
    virtual
    .FocusEvent			FOCUS_EVENT_RECORD
    end virtual
				rb .KeyEvent.Length + 16
    label .Length at $ - .
}

struc	_STARTUPINFO
{   label .
    .cb				dd ?	;  DWORD  cb;
				dd ?	;  align 8
    .lpReserved			dq ?	;  LPSTR  lpReserved;
    .lpDesktop			dq ?	;  LPSTR  lpDesktop;
    .lpTitle			dq ?	;  LPSTR  lpTitle;
    .dwX			dd ?	;  DWORD  dwX;
    .dwY			dd ?	;  DWORD  dwY;
    .dwXSize			dd ?	;  DWORD  dwXSize;
    .dwYSize			dd ?	;  DWORD  dwYSize;
    .dwXCountChars		dd ?	;  DWORD  dwXCountChars;
    .dwYCountChars		dd ?	;  DWORD  dwYCountChars;
    .dwFillAttribute		dd ?	;  DWORD  dwFillAttribute;
    .dwFlags			dd ?	;  DWORD  dwFlags;
    .wShowWindow		dw ?	;  WORD   wShowWindow;
    .cbReserved2		dw ?	;  WORD   cbReserved2;
				dd ?           ;  align 8
    .lpReserved2		dq ?	;  LPBYTE lpReserved2;
    .hStdInput			dq ?	;  HANDLE hStdInput;
    .hStdOutput			dq ?	;  HANDLE hStdOutput;
    .hStdError			dq ?	;  HANDLE hStdError;
    label .Length at $ - .
}
