
include "equates\windows.ash"
include "equates\kernel32.ash"
include "equates\user32.ash"
include "equates\gdi32.ash"
include "equates\opengl32.ash"

include "struc64\windows.ash"
include "struc64\kernel32.ash"
include "struc64\user32.ash"
include "struc64\gdi32.ash"

struc   MIXEDDB
{   label . byte
    label .low byte
    label .bit7 byte
    label .bit6 byte
    label .bit5 byte
    label .bit4 byte
    label .bit3 byte
    label .bit2 byte
    label .bit1 byte
    label .bit0 byte
    .high                       db ?
    label .Length at $ - .
}

struc   MIXEDWD
{   label . word
    .low                        MIXEDDB
    .high                       MIXEDDB
    label .Length at $ - .
}

struc   MIXEDDW
{   label . dword
    .low                        MIXEDWD
    .high                       MIXEDWD
    label .Length at $ - .
}

struc   MIXEDQW
{   label . qword
    .low                        MIXEDDW
    .high                       MIXEDDW
    label .Length at $ - .
}

struc   LDWORD
{   label . dword
    .llw                        dw ?
    .lhw                        dw ?
    label .Length at $ - .
}

struc   HDWORD
{   label . dword
    .hlw                        dw ?
    .hhw                        dw ?
    label .Length at $ - .
}

struc   WPARAM
{   label . qword
    .low                        LDWORD
    .high                       HDWORD
    label .Length at $ - .
}

struc   LPARAM
{   label . qword
    .low                        LDWORD
    .high                       HDWORD
    label .Length at $ - .
}

macro   WndProcArgs
{   .hWnd			dq ?    ;  HWND     hWnd
    .uMsg			dd ?    ;  LONG     uMsg
				dd ?    ;  align 8
    .wPar			WPARAM  ;  WPARAM   wPar
    .lPar			LPARAM  ;  LPARAM   lPar
}

.import	kernel32.dll, user32.dll, gdi32.dll,\
	opengl32.dll, glut32.dll, glu32.dll
include "imports\kernel32.ash"
include "imports\user32.ash"
include "imports\gdi32.ash"
include "imports\opengl32.ash"
include "imports\glut32.ash"
include "imports\glu32.ash"
