
include "Common\fixups.ash"
include "Pascal\LONG.ASH"

struc	STRA	text&
{   . db text
    label .SizeOf at 1
    label .Length at $ - .
      db 0
    label .Bytes at $ - .
}

struc	STRW	text&
{   align .SizeOf
    . du text
    label .SizeOf at 2
    label .Length at ( $ - . ) shr 1
      dw 0
    label .Bytes at $ - .
}

struc	TCHAR	text& { . STRW text }

macro	.export	name, [spec]
{   common	purge .edata
      macro .edata args& \{ err \}
      section '.export' export data readable writeable
      export.data: local .mod,.add,.nam,.ord,.c
      .c = 0
    forward .c = .c + 1
    common	dd 0, 0, 0, RVA .mod, 1, .c, .c, RVA .add, RVA .nam, RVA .ord
    .add:
    forward match proc==text, spec \{ dd RVA proc
    common .nam:
    forward local .n
		dd RVA .n
    common .ord: .c = 0
    forward	dw .c
      .c = .c + 1
    common .mod db name, 0
    forward match proc==text, spec \{ .n db text, 0 \}
    common local .x, .y, .z, .s1, .s2, .v1, .v2
      .x = .c shr 1
      while .x > 0
	.y = .x
	while .y < .c
	  .z = .y
	  while .z - .x >= 0
	    load .v1 dword from .nam + .z * 4
	    load .v2 dword from .nam + ( .z - .x ) * 4
	    .s1 = ( $ - RVA $ ) + .v1
	    .s2 = ( $ - RVA $ ) + .v2
	    while .v1 > 0
	      load .v1 from .s1 + % - 1
	      load .v2 from .s2 + % - 1
	      if .v1 <> .v2
		break
	      end if
	    end while
	    if .v1 < .v2
	      load .v1 dword from .nam + .z * 4
	      load .v2 dword from .nam + ( .z - .x ) * 4
	      store dword .v1 at  .nam + ( .z - .x ) * 4
	      store dword .v2 at  .nam + .z * 4
	      load .v1  word from .ord + .z * 2
	      load .v2  word from .ord + ( .z - .x ) * 2
	      store word .v1  at  .ord + ( .z - .x ) * 2
	      store word .v2  at  .ord + .z * 2
	    else
	      break
	    end if
	    .z = .z - .x
	  end while
	  .y = .y + 1
	end while
	.x = .x shr 1
    end while
}

macro	.import	[libs]
{   common	purge .idata
    macro .idata args& \{ err \}
    section '.idata' import data readable writeable
      import.data:
    forward libs#.spec:if defined libs#.value
		dd RVA libs#.look, 0, 0, RVA libs#.value, RVA libs#.addr
      end if
    common if $ > import.data
		dd 5 dup (0)
      end if
}

struc	import	from*, [fnc]
{   common	rb (- RVA $) and 7
      if defined .spec
	.look:
    forward	match proc==text, fnc \{
	if used proc
	  label proc qword at .\#_\#proc
	end if
	if used .\#_\#proc
	  if text eqtype ''
		dq RVA .\#_\#proc\#\\.value
	  else
		dq 0x8000000000000000 + text
	  end if
	end if
      \}
    common	if $ > .look
		dq 0
      end if
      .addr:
    forward	match proc==text, fnc \{
	if used .\#_\#proc
	  if text eqtype ''
	    .\#_\#proc dq RVA .\#_\#proc\#\\.value
	  else
	    .\#_\#proc dq 0x8000000000000000 + text
	  end if
	end if
      \}
    common	if $ > .addr
		dq 0
	.value	db from, 0
		rb RVA $ and 1
      end if
    forward	match proc==text, fnc \{
	if used .\#_\#proc & text eqtype ''
	  .\#_\#proc\#\\.value dw 0
		db text, 0
		rb RVA $ and 1
	end if
      \}
    common	end if
}

macro	.data
{   purge .data
    macro .data args& \{ err \}
    section '.data' data readable writeable
}

macro	.code	exec=main
{   purge .code
    macro .code \{ err \}
    section '.text' code readable executable
    virtual at rdx
      exec#.StartupInfo _STARTUPINFO
    end virtual
    entry $
	push	rbp
	mov	rbp, rsp
	lea	rsp, [rbp - ((exec#.StartupInfo.Length + 47) and -16)]
	lea	rcx, [rbp - exec#.StartupInfo.Length]
	call	[kernel32.dll_GetStartupInfoW]
	xor	ecx, ecx
	call	[kernel32.dll_GetModuleHandleW]
	mov	rbx, rax
	or	eax, -1
	test	rbx, rbx
	jz	@f
	call	[kernel32.dll_GetCommandLineW]
	call	ParseCommandLine
	mov	rcx, rax
	call	GetArgvCount
	mov	r9, rax
	mov	r8, rcx
	lea	rdx, [rbp - exec#.StartupInfo.Length]
	mov	rcx, rbx
	call	exec

  @@:
	leave
	push	rax
	mov	rcx, rax
	sub	rsp, 32
	call	[kernel32.dll_ExitProcess]

  ParseCommandLine:
	pushfq
	push	rdi
	push	rsi
	call	@f

  @@:
	cld
	pop	r8
	xor	ecx, ecx
	mov	rsi, rax
	add	r8, .count - @b
	lea	rdi, [rcx + 1]
	mov	edx, ' '
	mov	r9,  rsi
	sub	rcx, rax
	xor	eax, eax
	call	.parse
	lea	rax, [rcx + rdi * 2 + 15]
	mov	edx, edi
	mov	rsi, rsp
	and	al, 0xF0
	sub	rsp, rax
	mov	rdi, rsp
	movs	qword [rdi], [rsi]
	movs	qword [rdi], [rsi]
	movs	qword [rdi], [rsi]
	movs	qword [rdi], [rsi]
	movs	qword [rdi], [rsi]
	movs	qword [rdi], [rsi]
	movs	qword [rdi], [rsi]
	movs	qword [rdi], [rsi]
	lea	rdx, [rdi + rdx * 2]
	mov	rsi, r9
	mov	al, cl
	mov	r9, rdi
	and	al, 3
	mov	rdi, rdx
	shr	rcx, 3
	jz	@f
    rep movs	qword [rdi], [rsi]

  @@:
	or	cl, al
	jz	@f
    rep movs	byte [rdi], [rsi]

  @@:
	sub	rcx, r9
	mov	rsi, rdx
	mov	rdi, r9
	add	r8, .write - .count
	lea	rax, [rsi + rcx]
	stos	word [rdi]
	mov	edx, ' '
	xor	eax, eax
	call	.parse
	mov	rax, r9
	pop	rsi
	pop	rdi
	popfq
	retn

  @@:
	cmp	eax, '"'
	jz	@f
	cmp	eax, edx
	jz	.break

  .parse:
	lods	word [rsi]
	test	ax, ax
	jnz	@b
	add	rcx, rsi
	retn

  @@:
	xor	dl, '"' xor ' '
	jmp	.parse

  .break:
	jmp	r8

  @@:
	lods	word [rsi]

  .space:
	sub	ax, [rsi]
	jz	@b
	cmp	eax, edx
	retn

  .count:
	call	.space
	jz	.parse
	inc	rdi
	jmp	.parse

  .write:
	xor	[rsi - 2], ax
	call	.space
	jz	.parse
	lea	rax, [rsi + rcx]
	stos	word [rdi]
	xor	eax, eax
	jmp	.parse

  GetArgvCount:
	movzx	eax, word [rcx]
	shr	eax, 1
	retn

  GetArgvIndex:
	movzx	eax, word [rcx]
	add	edx, edx
	cmp	rdx, rax
	jge	@f
	movzx	eax, word [rcx + rdx]
	add	rax, rcx
	clc
	retn

  @@:
	xor	eax, eax
	stc
	retn
}

macro	.resource from&
{   purge .resource
    macro .resource args& \{ err \}
    match any, from \{ section '.rsrc' data readable resource from any \}
    match , from \{ section '.rsrc' data readable resource \}
}

macro	.fixups
{   purge .fixups
    macro .fixups \{ err \}
    postpone \{ section '.reloc' fixups data readable discardable \}
}

include "Windows\win64.ash"