if used WaitAnyKey
  proc	WaitAnyKey, cdecl
  var
    .handle			dq ?
    .mode			dq ?
    .proceed			dd ?
    .buffer			db 4 dup ?
    .inputs			_INPUT_RECORD
  begin
	jrcxz	@f
	invoke	[GetStdHandle], STD_OUTPUT_HANDLE
	invoke	[WriteConsoleA], rax, addr [.echo], .echo.Length, addr [.proceed], NULL

  @@:
	invoke	[GetStdHandle], STD_INPUT_HANDLE
	mov	[.handle], rax
	invoke	[GetConsoleMode], rax, addr [.mode]
	mov	rdx, [.mode]
	and	rdx, not ( ENABLE_LINE_INPUT or ENABLE_ECHO_INPUT )
	invoke	[SetConsoleMode], [.handle], rdx
	invoke	[ReadConsoleA], [.handle], addr [.buffer], 1, addr [.proceed], NULL

  @@:
	invoke	[GetNumberOfConsoleInputEvents], [.handle], addr [.proceed]
	cmp	[.proceed], 0
	jz	@f
	invoke	[ReadConsoleInput], [.handle], addr [.inputs], 1, addr [.proceed]
	jmp	@b

  @@:
	invoke	[SetConsoleMode], [.handle], [.mode]
  return clc
end if;used WaitAnyKey

if used malloc
  proc	malloc, cdecl
    .cbSize			dq ?
  begin
	mov	[.cbSize], rcx
	invoke	[GetProcessHeap]
	test	rax, rax
	jz	@f
	invoke	[HeapAlloc], rax, HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY, [.cbSize]
	test	rax, rax
	jz	@f
  return clc

    @@:
  return stc
end if

if used mrealloc
  proc	mrealloc, cdecl
    .lpBlock			dq ?
    .cbNewSize			dq ?
  begin
	mov	[.lpBlock], rcx
	mov	[.cbNewSize], rdx
	invoke	[GetProcessHeap]
	test	rax, rax
	jz	@f
	invoke	[HeapRealloc], rax, HEAP_NO_SERIALIZE, [.lpBlock], [.cbNewSize]
	test	rax, rax
	jz	@f
  return clc

    @@:
  return stc
end if

if used mfree
  proc	mfree, cdecl
    .lpBlock			dq ?
  begin
	mov	[.lpBlock], rcx
	invoke	[GetProcessHeap]
	test	rax, rax
	jz	@f
	invoke	[HeapFree], rax, HEAP_NO_SERIALIZE, [.lpBlock]
	test	rax, rax
	jz	@f
  return clc

    @@:
  return stc
end if

if used WindowMessageLoop
  proc	WindowMessageLoop, cdecl
    .hWnd			dq ?
    .Idle			dq ?
    .wPar			dq ?
    .lPar			dq ?
  var
    .msg			tagMSG
    .Handles			dq ?
  begin
	mov	[.hWnd], rcx
	mov	[.Idle], rdx
	mov	[.wPar], r8
	mov	[.lPar], r9
	invoke	[CreateEventW], NULL, true, false, NULL
	mov	[.Handles], rax
	jmp	.start

    @@:
	invoke	[TranslateMessage], addr [.msg]
	invoke	[DispatchMessageW], addr [.msg]

    .start:
	invoke	[PeekMessageW], addr [.msg], NULL, NULL, NULL, PM_REMOVE
	test	al, al
	jz	.idle
	cmp	[.msg.message], WM_QUIT
	jnz	@b
	invoke	[CloseHandle], [.Handles]
  return nop,	[.msg.wParam]

    .idle:
	cmp	[.Idle], -1
	jz	@f
	invoke	[.Idle], [.hWnd], WM_USER, [.wPar], [.lPar]
	test	al, al
	jz	.start

    @@:
	invoke	[MsgWaitForMultObjects], 1, addr [.Handles], false, INFINITE, QS_ALLINPUT
	cmp	eax, 1
	jz	.start
	invoke	[CloseHandle], [.Handles]
  return nop,	2
end if; used WindowMessageLoop

if used CreatePatternBrushFromBitmap
  proc	CreatePatternBrushFromBitmap, cdecl
  var
    .hBrush			dq ?
  begin
	mov	rdx, rcx
	invoke	[LoadImageW], NULL, rdx, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE or LR_SHARED
	test	rax, rax
	jz	.error
	mov	[.hBrush], rax
	invoke	[CreatePatternBrush], rax
	test	rax, rax
	jz	@f
	xchg	rax, [.hBrush]
	invoke	[DeleteObject], rax
  return clc,	[.hBrush]

    @@:
	invoke	[DeleteObject], [.hBrush]

    .error:
  return stc,	NULL
end if;used CreatePatternBrushFromBitmap