mainWndW.idCursor		= 1
mainWndW.idIcon			= 1
mainWndW.idIconSm		= 1
mainWndW.idTitle		= 1
mainWndW.cStyle			= CS_HREDRAW or CS_VREDRAW or CS_GLOBALCLASS or CS_OWNDC
mainWndW.eStyle			= WS_EX_OVERLAPPEDWINDOW
mainWndW.wStyle			= WS_OVERLAPPEDWINDOW

mainWndW.cname			STRW "TmainWnd"
mainWndW.title			STRW "Form1"
mainWndW.Timers.Repaint		STRW "Repaint"

NORTH				= 0
EAST				= 1
SOUTH				= 2
WEST				= 3
OVER				= 4

struc	mainWndW_chain
{   label .
    .list			dq ?
    .posX			dd ?
    .posY			dd ?
    label .Length at $ - .
}

struc	mainWndW_block
{   label .
    .move			db ?, ?
    .size			dw ?
    .time			dd ?
    .head			dq ?
    .body			dq ?
    .food			dq ?
    .base			dq ?
    .tail			dq ?
    .eatX			dd ?
    .eatY			dd ?
    label .Length at $ - .
}

struc	mainWndW_class
{   label .
    label .Length at $ - .
}

struc	mainWndW_extra
{   label .
    label .Length at $ - .
}

proc	mainWndW, cdecl
  WndProcArgs
begin
  .block assume r10, mainWndW_block
  .class assume r10, mainWndW_class
  .extra assume r10, mainWndW_extra
	mov	[.hWnd], rcx
	mov	[.uMsg], edx
	mov	[.wPar], r8
	mov	[.lPar], r9
	invoke	[GetWindowLongW], rcx, GWL_USERDATA
	mov	rcx, [.hWnd]
	mov	edx, [.uMsg]
	mov	r8,  [.wPar]
	mov	r9,  [.lPar]
	leave
	test	rax, rax
	jz	@f

	cmp	edx, WM_TIMER
	jz	.FormTimer
	cmp	edx, WM_PAINT
	jz	.FormPaint
	cmp	edx, WM_KEYDOWN
	jz	.FormKeyDown

  @@:
	cmp	edx, WM_CREATE
	jz	.FormCreate
	cmp	edx, WM_DESTROY
	jz	.FormDestroy

  .default:
	jmp	[DefWindowProcW]

proc	mainWndW.FormCreate, cdecl, r10
  WndProcArgs
var
  .lpBlock			dq ?
  .client			RECT
begin
  .chain assume	rax, mainWndW_chain
	mov	[.lpBlock], NULL
  if mainWndW.block.Length <> 0
	invoke	malloc, mainWndW.block.Length
	jc	.error
	mov	[.lpBlock], rax
	invoke	[SetWindowLongW], [.hWnd], GWL_USERDATA, rax
  else
	mov	[.lpBlock], NULL
  end if
	invoke	[GetClientRect], [.hWnd], addr [.client]
	invoke	CreatePatternBrushFromBitmap, addr [.head_bitmap_filename]
	jc	.error
	mov	r10, [.lpBlock]
	mov	[mainWndW.block.head], rax
	invoke	CreatePatternBrushFromBitmap, addr [.body_bitmap_filename]
	jc	.error
	mov	r10, [.lpBlock]
	mov	[mainWndW.block.body], rax
	invoke	CreatePatternBrushFromBitmap, addr [.food_bitmap_filename]
	jc	.error
	mov	r10, [.lpBlock]
	mov	[mainWndW.block.food], rax
	mov	[mainWndW.block.time], 512
	mov	[mainWndW.block.size], 12
	mov	[mainWndW.block.move], EAST
	invoke	malloc, .chain.Length
	jc	.error
	mov	r10, [.lpBlock]
	mov	[mainWndW.block.base], rax
	mov	[mainWndW.block.tail], rax
	mov	ecx, [.client.bottom]
	mov	edx, [.client.right]
	sub	ecx, [.client.top]
	sub	edx, [.client.left]
	shr	ecx, 1
	shr	edx, 1
	and	ecx, -32
	and	edx, -32
	mov	[.client.left], edx
	mov	[.client.top], ecx
	sub	edx, 64
	mov	[.chain.posX], edx
	mov	[.chain.posY], ecx
	invoke	malloc, .chain.Length
	jc	.error
	mov	r10, [.lpBlock]
	mov	rdx, rax
	xchg	[mainWndW.block.base], rdx
	mov	[.chain.list], rdx
	mov	[.chain.list + rdx - rax], rax
	mov	ecx, [.client.top]
	mov	edx, [.client.left]
	sub	edx, 32
	mov	[.chain.posY], ecx
	mov	[.chain.posX], edx
	invoke	malloc, .chain.Length
	mov	r10, [.lpBlock]
	mov	rdx, rax
	xchg	rdx, [mainWndW.block.base]
	mov	[.chain.list], rdx
	xor	[.chain.list + rdx - rax], rax
	mov	ecx, [.client.top]
	mov	edx, [.client.left]
	mov	[.chain.posY], ecx
	mov	[.chain.posX], edx

	mov	r8d, [mainWndW.block.time]
	invoke	[SetTimer], [.hWnd], addr [.repaint_timer], r8, NULL

	invoke	[IsWindowVisible], [.hWnd]
	test	al, al
	jnz	@f
	invoke	[ShowWindow], [.hWnd], SW_SHOWNORMAL
	invoke	[UpdateWindow], [.hWnd]

  @@:
return	nop,	1

  .error:
return	nop,	0

proc	mainWndW.FormTimer, cdecl, r10
  WndProcArgs
var
  .lpBlock			dq ?
  .new				POINT
  .client			RECT
begin
  .chain assume	rdx, mainWndW_chain
	lea	rcx, [mainWndW.FormCreate.repaint_timer]
	mov	r10, rax
	cmp	[.wPar], rcx
	jnz	.done
	mov	[.lpBlock], r10
	mov	rdx, [mainWndW.block.base]
	mov	al, [mainWndW.block.move]
	mov	r8d, [.chain.posX]
	mov	r9d, [.chain.posY]
	cmp	al, NORTH
	jz	.north
	cmp	al, EAST
	jz	.east
	cmp	al, SOUTH
	jz	@f
	cmp	al, WEST
	jnz	.done
	sub	r8d, 32
	jmp	.next

  @@:
	add	r9d, 32
	jmp	.next

  .east:
	add	r8d, 32
	jmp	.next

  .north:
	sub	r9d, 32

  .next:
	mov	rdx, [mainWndW.block.tail]
	mov	[.new.x], r8d
	mov	[.new.y], r9d
	cmp	r8d, [mainWndW.block.eatX]
	jnz	.move
	cmp	r9d, [mainWndW.block.eatY]
	jnz	.move
	dec	[mainWndW.block.size]
	jnz	@f
	mov	eax, [mainWndW.block.time]
	shr	eax, 2
	mov	[mainWndW.block.size], 12
	shr	[mainWndW.block.time], 1
	add	[mainWndW.block.time], eax
	invoke	[KillTimer], [.hWnd], addr [mainWndW.FormCreate.repaint_timer]
	mov	r10, [.lpBlock]
	mov	r8d, [mainWndW.block.time]
	invoke	[SetTimer], [.hWnd], addr [mainWndW.FormCreate.repaint_timer], r8, NULL

  @@:
	invoke	malloc, .chain.Length
	jc	.done
	mov	r10, [.lpBlock]
	mov	r8d, [.new.x]
	mov	r9d, [.new.y]
	mov	rdx, rax
	jmp	.push

  .move:
	mov	rax, [.chain.list]
	xor	[.chain.list + rax - rdx], rdx
	mov	[mainWndW.block.tail], rax

  .push:
	mov	[.chain.posX], r8d
	mov	[.chain.posY], r9d
	mov	rax, rdx
	xchg	rax, [mainWndW.block.base]
	mov	[.chain.list], rax
	xor	[.chain.list + rax - rdx], rdx
	invoke	[GetClientRect], [.hWnd], addr [.client]
	mov	r8d, [.new.x]
	mov	r9d, [.new.y]
	mov	r10, [.lpBlock]
	and	[.client.bottom], -32
	and	[.client.right],  -32
	sub	[.client.bottom],  32
	sub	[.client.right],   32
	cmp	[.client.left], r8d
	jg	.over
	cmp	[.client.top], r9d
	jg	.over
	cmp	r8d, [.client.right]
	jg	.over
	cmp	r9d, [.client.bottom]
	jg	.over
	mov	rdx, [mainWndW.block.base]
	mov	rax, [.chain.list]

  .loop:
	xchg	rax, rdx
	cmp	[.chain.posX], r8d
	jnz	@f
	cmp	[.chain.posY], r9d
	jz	.over

  @@:
	xor	rax, [.chain.list]
	jnz	.loop
	jmp	@f

  .over:
	mov	[mainWndW.block.move], OVER

  @@:
	invoke	[InvalidateRect], [.hWnd], NULL, TRUE

  .done:
return	nop,	0

proc	mainWndW.FormPaint, cdecl, r10
  WndProcArgs
var
  .lpBlock			dq ?
  .ring				dq ?
  .prev				dq ?
  .brush			dq ?
  .client			RECT
  .ps				PAINTSTRUCT
begin
  .chain assume rdx, mainWndW_chain
	mov	[.lpBlock], rax
	invoke	[BeginPaint], [.hWnd], addr [.ps]
	mov	r10, [.lpBlock]
	cmp	[mainWndW.block.move], OVER
	jnz	@f
	invoke	[GetClientRect], [.hWnd], addr [.client]
	mov	edx, [.client.left]
	mov	r8d, [.client.top]
	mov	r9d, [.client.right]
	mov	eax, [.client.bottom]
	dec	edx
	dec	r8d
	inc	r9d
	inc	eax
	invoke	[Rectangle], [.ps.hdc], rdx, r8, r9, rax
	invoke	[TextOutW], [.ps.hdc], 100, 100, addr [.GameOver], .GameOver.Length
	jmp	.done

  @@:
	invoke	[SelectObject], [.ps.hdc], [mainWndW.block.food]
	mov	r10, [.lpBlock]
	mov	[.brush], rax
	mov	edx, [mainWndW.block.eatX]
	mov	r8d, [mainWndW.block.eatY]
	lea	r9, [rdx + 32]
	lea	rax, [r8 + 32]
	invoke	[Rectangle], [.ps.hdc], rdx, r8, r9, rax
	mov	r10, [.lpBlock]
	mov	rdx, [mainWndW.block.base]
	mov	[.ring], rdx
	invoke	[SelectObject], [.ps.hdc], [mainWndW.block.head]
	mov	rdx, [.ring]
	mov	r8d, [.chain.posY]
	mov	edx, [.chain.posX]
	lea	r9, [rdx + 32]
	lea	rax, [r8 + 32]
	invoke	[Rectangle], [.ps.hdc], rdx, r8, r9, rax
	mov	r10, [.lpBlock]
	invoke	[SelectObject], [.ps.hdc], [mainWndW.block.body]
	mov	rdx, [.ring]
	mov	rax, [.chain.list]

  .loop:
	mov	[.prev], rdx
	mov	[.ring], rax
	mov	rdx, rax
	mov	r8d, [.chain.posY]
	mov	edx, [.chain.posX]
	lea	r9, [rdx + 32]
	lea	rax, [r8 + 32]
	invoke	[Rectangle], [.ps.hdc], rdx, r8, r9, rax
	mov	rdx, [.ring]
	mov	rax, [.prev]
	xor	rax, [.chain.list]
	jnz	.loop
	invoke	[SelectObject], [.ps.hdc], [.brush]

  .done:
	invoke	[EndPaint], [.hWnd], addr [.ps]
return	nop,	0

proc	mainWndW.FormKeyDown, cdecl, r10
  WndProcArgs
begin
	mov	r10, rax
	cmp	r8d, 0x25
	jnz	@f
	mov	al, WEST
	jmp	.next

  @@:
	cmp	r8d, 0x28
	jnz	@f
	mov	al, SOUTH
	jmp	.next

  @@:
	cmp	r8d, 0x27
	jnz	@f
	mov	al, EAST
	jmp	.next

  @@:
	cmp	r8d, 0x26
	jnz	.skip
	mov	al, NORTH

  .next:
	xor	al, [mainWndW.block.move]
	jz	.skip
	cmp	al, 2
	jz	.skip
	test	al, 4
	jnz	.skip
	xor	[mainWndW.block.move], al

  .skip:
return	nop,	0

proc	mainWndW.FormDestroy, cdecl, r10
  WndProcArgs
var
  .lpBlock			dq ?
begin
	mov	[.lpBlock], rax
	cmp	[.lpBlock], NULL
	jz	@f

	mov	r10, [.lpBlock]
	invoke	[DeleteObject], [mainWndW.block.food]
	mov	r10, [.lpBlock]
	invoke	[DeleteObject], [mainWndW.block.body]
	mov	r10, [.lpBlock]
	invoke	[DeleteObject], [mainWndW.block.head]

	invoke	mfree, [.lpBlock]

  @@:
	invoke	[PostQuitMessage], 0
return	nop,	0

proc	mainWndW.FormIdle, cdecl
  WndProcArgs
begin

return	nop,	1

proc	mainWndW.Create, cdecl
  .lParam			dq ?
var
  .buf_size			= 256
  .buf				dw .buf_size dup ?
  .wce				WNDCLASSEX
begin
	mov	[.lParam], rdx
	mov	[.wce.cbSize], .wce.Length
	mov	[.wce.style], mainWndW.cStyle
	mov	[.wce.lpfnWndProc], mainWndW
	mov	[.wce.cbClsExtra], mainWndW.class.Length
	mov	[.wce.cbWndExtra], mainWndW.extra.Length
	test	rcx, rcx
	jnz	@f
	invoke	[GetModuleHandleW], NULL
	mov	rcx, rax

  @@:
	mov	[.wce.hInstance], rcx
	invoke	[LoadIconW], rcx, mainWndW.idIcon
	test	rax, rax
	jnz	@f
	invoke	[LoadIconW], NULL, IDI_APPLICATION
	test	rax, rax
	jz	.error

  @@:
	mov	[.wce.hIcon], rax
	invoke	[LoadCursorW], [.wce.hInstance], mainWndW.idCursor
	test	rax, rax
	jnz	@f
	invoke	[LoadCursorW], NULL, IDC_ARROW
	test	rax, rax
	jz	.error

  @@:
	lea	rdx, [mainWndW.cname]
	mov	[.wce.hCursor], rax
	mov	[.wce.hbrBackground], COLOR_WINDOWFRAME + 1
	mov	[.wce.lpszMenuName], NULL
	mov	[.wce.lpszClassName], rdx
	invoke	[LoadIconW], [.wce.hInstance], mainWndW.idIconSm
	test	rax, rax
	jnz	@f
	invoke	[LoadIconW], NULL, IDI_APPLICATION
	test	rax, rax
	jz	.error

  @@:
	mov	[.wce.hIconSm], rax
	invoke	[RegisterClassExW], addr [.wce]
	test	ax, ax
	jz	.error
	invoke	[LoadStringW], [.wce.hInstance], mainWndW.idTitle, addr [.buf], .buf_size
	mov	r8, rax
	test	rax, rax
	jnz	@f
	lea	r8, [mainWndW.title]

  @@:
	lea	rdx, [mainWndW.cname]
	mov	rax, CW_USEDEFAULT
	invoke	[CreateWindowExW], mainWndW.eStyle, rdx, r8, mainWndW.wStyle,\
				   rax, rax, rax, rax, HWND_DESKTOP, NULL,\
				   [.wce.hInstance], [.lParam]
	test	rax, rax
	jz	.error
return	clc

  .error:
return	stc,	NULL

mainWndW.FormCreate.head_bitmap_filename	STRW ".\data\head.bmp"
mainWndW.FormCreate.body_bitmap_filename	STRW ".\data\body.bmp"
mainWndW.FormCreate.food_bitmap_filename	STRW ".\data\food.bmp"
mainWndW.FormCreate.repaint_timer		STRW "Repaint"
mainWndW.FormPaint.GameOver			STRW "Game Over!"